<?php
/**
 * Created by PhpStorm.
 * User: k
 * Date: 10.02.2017
 * Time: 20:10
 */

namespace App\Http\Controllers;

use App\Paper\HtmlToPos;
use Illuminate\Support\Facades\DB;
use Mike42\Escpos\PrintConnectors\FilePrintConnector;
use Mike42\Escpos\Printer;
use Intervention\Image\ImageManagerStatic as Image;
use Mike42\Escpos\EscposImage;
use Illuminate\Http\Request;

class Main extends Controller
{

    public function imagePrint(Request $request)
    {

        if ($request->hasFile('photo')) {
            $file = $request->photo;
        } else {
            $file = $request->input('url');
        }

        $image = Image::make($file);
        if ($image->width() > $image->height()) {
            $image->rotate(90);
        }


        $image = $image->greyscale()
            ->resize(300, null, function ($constraint) {
                $constraint->aspectRatio();
                $constraint->upsize();
            });


        $fileName = storage_path('temp.png');
        $image->save($fileName, 100);


        $img = imagecreatefrompng($fileName);
//        imagefilter($img, IMG_FILTER_GRAYSCALE);
        $width = imagesx($img);
        $height = imagesy($img);
        $img_arr = array();

// Parse image (can be combined with dither stage, but combining them is slower.)

        for ($y = 0; $y < $height; $y++) {
            for ($x = 0; $x < $width; $x++) {
                $img_arr[$x][$y] = imagecolorat($img, $x, $y);
            }
        }


// make a b/w output image.
        $output = imagecreate($width, $height);
        $black = imagecolorallocate($output, 0, 0, 0); //background color.
        $white = imagecolorallocate($output, 0xff, 0xff, 0xff);


        for ($y = 1; $y < $height - 3; $y++) {
            for ($x = 1; $x < $width - 3; $x++) {
                $old = $img_arr[$x][$y];
                if ($old > 0xffffff * .5) { // This is the b/w threshold. Currently @ halfway between white and black.
                    $new = 0xffffff;
                    imagesetpixel($output, $x, $y, $white); // Only setting white pixels, because the image is already black.
                } else {
                    $new = 0x000000;
                }
                $quant_error = $old - $new;
                $error_diffusion = (1 / 8) * $quant_error; //I can do this because this dither uses 1 value for the applied error diffusion.
                //dithering here.
                $img_arr[$x + 1][$y] += $error_diffusion;
                $img_arr[$x + 2][$y] += $error_diffusion;
                $img_arr[$x - 1][$y + 1] += $error_diffusion;
                $img_arr[$x][$y + 1] += $error_diffusion;
                $img_arr[$x + 1][$y + 1] += $error_diffusion;
                $img_arr[$x][$y + 2] += $error_diffusion;
            }
        }

// plop out a png of the dithered image.

//        Header("Content-type: image/png");
        imagepng($output, $fileName, 9); //to print to screen


        $connector = new FilePrintConnector("/dev/usb/lp0");
        $printer = new Printer($connector);
        $img = EscposImage::load($fileName, false);
        $printer->bitImage($img);

        $printer->feed(4);

        return back();
    }

    public function listView(Request $request)
    {
        $notes = DB::select('SELECT * FROM note ORDER BY updated_at DESC');
        return view('list', [
            'notes' => $notes,
            'title' => $request->old('title'),
            'text' => $request->old('text')
        ]);
    }

    public function form(Request $request)
    {
        return view('create', [
            'title' => $request->old('title'),
            'text' => $request->old('text')
        ]);
    }

    public function printText($id)
    {
        $note = DB::table('note')->where('id', $id)->first();
        $this->sendPrint($note->topic, $note->text);
        return back();
    }

    public function edit(Request $request, $id, $slug)
    {
        $note = DB::table('note')->where('id', $id)->first();
        if ($request->isMethod('post')) {
            if ($request->exists('save')) {
                DB::table('note')
                    ->where('id', $note->id)
                    ->update([
                        'topic' => $request->input('title'),
                        'topic_slug' => str_slug($request->input('title'), '_'),
                        'text' => $request->input('text'),
                        'updated_at' => time(),
                    ]);
            } elseif ($request->exists('delete')) {
                DB::table('note')
                    ->where('id', $note->id)
                    ->delete();

                return redirect()->route('list');

            } elseif ($request->exists('print')) {
                $this->sendPrint($request->input('title'), $request->input('text'));
            }
            return redirect()->route('edit', ['id' => $note->id, 'slug' => $note->topic_slug]);
        } else {
            return view('edit', [
                'title' => $note->topic,
                'text' => $note->text,
                'id' => $note->id,
                'topic_slug' => $note->topic_slug,
            ]);
        }
    }

    public function sendPrint($title, $text)
    {
        $connector = new FilePrintConnector("/dev/usb/lp0");
        $printer = new Printer($connector);



//        $printer->setFont(Printer::FONT_B);
        if (strlen($title)) {
            $printer->setDoubleStrike(true);
            $printer->setJustification(Printer::JUSTIFY_CENTER);
            $printer->setEmphasis(true);
            $printer->text($title . "\n\n");
            $printer->setEmphasis(false);
            $printer->setJustification(Printer::JUSTIFY_LEFT);
            $printer->setDoubleStrike(false);
        }
        $htmlToPos = new HtmlToPos();
        $printer->text($htmlToPos->convert($text));

        $printer->feed(4);
        $printer->close();
    }

    public function main(Request $request)
    {
        if ($request->exists('save')) {
            $id = DB::table('note')
                ->insertGetId([
                    'topic' => $request->input('title'),
                    'topic_slug' => str_slug($request->input('title'), '_'),
                    'text' => $request->input('text'),
                    'created_at' => time(),
                    'updated_at' => time()
                ]);
            $note = DB::table('note')->where('id', $id)->first();
            return redirect()->route('edit', ['id' => $note->id, 'slug' => $note->topic_slug]);
        } else {
            $this->sendPrint($request->input('title'), $request->input('text'));
            return back()->withInput();
        }

    }

}